/* template.h
 * Header file for the Linux CAN-bus driver.
 * Written by Arnaud Westenberg email:arnaud@wanadoo.nl
 * Rewritten for new CAN queues by Pavel Pisa - OCERA team member
 * email:pisa@cmp.felk.cvut.cz
 * This software is released under the GPL-License.
 * Version lincan-0.3  17 Jun 2004
 */


#define TS732_BASE_IO		0x400
#define TS732_BASE_RANGE	0xF
#define TS732_CTR_REG		0x0
#define TS732_CAN_BIT		0x4

#define TS732_CAN_IO		0x500
#define TS732_CAN_RANGE		0xFF

#define TS732_BASE_ADDR		0x72000000
#define TS732_BASE_SIZE		TS732_CAN_IO+TS732_CAN_RANGE

#define TS732_IRQ			40
#define TS732_CLOCK			25000

int ts732_request_io(struct candevice_t *candev);
int ts732_release_io(struct candevice_t *candev);
int ts732_reset(struct candevice_t *candev);
int ts732_init_hw_data(struct candevice_t *candev);
int ts732_init_chip_data(struct candevice_t *candev, int chipnr);
int ts732_init_obj_data(struct canchip_t *chip, int objnr);
void ts732_write_register(unsigned data, unsigned long address);
unsigned ts732_read_register(unsigned long address);
int ts732_program_irq(struct candevice_t *candev);
