/* template.h
 * Header file for the Linux CAN-bus driver.
 * Written by Arnaud Westenberg email:arnaud@wanadoo.nl
 * Rewritten for new CAN queues by Pavel Pisa - OCERA team member
 * email:pisa@cmp.felk.cvut.cz
 * This software is released under the GPL-License.
 * Version lincan-0.3  17 Jun 2004
 */


#define TSDMX_BASE_IO		0x400
#define TSDMX_BASE_RANGE	0xFF
#define TSDMX_MAGIC_REG		0X22
#define TSDMX_MAGIC_VALUE	0x8bb7

#define TSDMX_CAN_IO1		0x500
#define TSDMX_CAN_IO2		0x600
#define TSDMX_CAN_RANGE		0xFF

#define TSDMX_BASE_ADDR		0x72000000
#define TSDMX_BASE_SIZE		TSDMX_CAN_IO2+TSDMX_CAN_RANGE

#define TSDMX_IRQ			40
#define TSDMX_CLOCK			25000

int tsdmx_request_io(struct candevice_t *candev);
int tsdmx_release_io(struct candevice_t *candev);
int tsdmx_reset(struct candevice_t *candev);
int tsdmx_init_hw_data(struct candevice_t *candev);
int tsdmx_init_chip_data(struct candevice_t *candev, int chipnr);
int tsdmx_init_obj_data(struct canchip_t *chip, int objnr);
void tsdmx_write_register(unsigned data, unsigned long address);
unsigned tsdmx_read_register(unsigned long address);
int tsdmx_program_irq(struct candevice_t *candev);
